diff --git a/lib/hive/tui/update.rb b/lib/hive/tui/update.rb
index f17a433b..5c77f636 100644
--- a/lib/hive/tui/update.rb
+++ b/lib/hive/tui/update.rb
@@ -77,6 +77,10 @@ module Hive
           [ apply_open_red_status_detail(model, message), nil ]
         when Messages::RedStatusDetailScroll
           [ apply_red_status_detail_scroll(model, message), nil ]
+        when Messages::IdeaPreviewLoaded
+          [ apply_idea_preview_loaded(model, message), nil ]
+        when Messages::IdeaPreviewFailed
+          [ apply_idea_preview_failed(model, message), nil ]
         when Messages::Back
           [ apply_back(model), nil ]
         when Messages::ProjectScope
@@ -782,13 +786,60 @@ end
           closed = model.with(mode: :grid, red_status_detail_state: nil)
           visible = visible_snapshot(closed)
           visible.nil? ? closed : closed.with(cursor: reclamp_cursor(visible, closed.cursor))
-        when :idea_preview then model.with(mode: :grid, idea_preview_text: nil, idea_preview_slug: nil)
+        when :idea_preview then close_idea_preview(model)
         when :help, :filter then model.with(mode: :grid)
         when :new_idea_project then apply_new_idea_cancelled(model)
         else model
         end
       end
 
+      # Close the info panel and restore the cursor to the captured task
+      # identity when it still exists in the scoped/filtered snapshot.
+      # If polling removed the task, fall back to reclamp rather than
+      # selecting an unrelated coordinate.
+      def close_idea_preview(model)
+        state = model.idea_preview_state
+        closed = model.with(mode: :grid, idea_preview_state: nil)
+        return closed if state.nil?
+
+        visible = visible_snapshot(closed)
+        return closed if visible.nil?
+
+        cursor = cursor_for_row(visible, state.row) || reclamp_cursor(visible, closed.cursor)
+        closed.with(cursor: cursor)
+      end
+
+      # Apply a successful background load only when the open panel's
+      # request token still matches. Closing or opening another row
+      # invalidates the token so late results cannot resurrect content.
+      def apply_idea_preview_loaded(model, msg)
+        state = model.idea_preview_state
+        return model unless model.mode == :idea_preview && state
+        return model unless state.token == msg.token
+
+        model.with(
+          idea_preview_state: state.with(
+            status: :ready,
+            content: msg.content,
+            error_message: nil
+          )
+        )
+      end
+
+      def apply_idea_preview_failed(model, msg)
+        state = model.idea_preview_state
+        return model unless model.mode == :idea_preview && state
+        return model unless state.token == msg.token
+
+        model.with(
+          idea_preview_state: state.with(
+            status: :error,
+            content: nil,
+            error_message: msg.error.to_s
+          )
+        )
+      end
+
       def new_idea_project_choices(model)
         Array(model.snapshot&.projects).select { |project| project.error.nil? }
       end
@@ -816,8 +867,37 @@ end
       def find_row_for_detail(snapshot, original_row)
         return nil if snapshot.nil? || original_row.nil?
 
-        snapshot.rows.find { |row| row.folder == original_row.folder } ||
-          snapshot.rows.find { |row| row.project_name == original_row.project_name && row.slug == original_row.slug && row.stage == original_row.stage }
+        folder = original_row.folder.to_s
+        folder_match = snapshot.rows.find { |row| !folder.empty? && row.folder.to_s == folder }
+        folder_match || snapshot.rows.find { |row| same_task_identity?(row, original_row) }
+      end
+
+      # Locate `[project_idx, row_idx]` for a captured row identity in the
+      # current visible snapshot. Prefers folder match, then the stable
+      # project+slug identity (the stage and folder both change on advance).
+      def cursor_for_row(visible, original_row)
+        return nil if visible.nil? || original_row.nil?
+
+        folder = original_row.folder.to_s
+        unless folder.empty?
+          visible.projects.each_with_index do |project, project_idx|
+            project.rows.each_with_index do |row, row_idx|
+              return [ project_idx, row_idx ] if row.folder.to_s == folder
+            end
+          end
+        end
+
+        visible.projects.each_with_index do |project, project_idx|
+          project.rows.each_with_index do |row, row_idx|
+            return [ project_idx, row_idx ] if same_task_identity?(row, original_row)
+          end
+        end
+
+        nil
+      end
+
+      def same_task_identity?(row, original_row)
+        row.project_name == original_row.project_name && row.slug == original_row.slug
       end
 
       def red_status_row?(row)
diff --git a/lib/hive/tui/views/idea_preview.rb b/lib/hive/tui/views/idea_preview.rb
index c9fdfb09..92811e73 100644
--- a/lib/hive/tui/views/idea_preview.rb
+++ b/lib/hive/tui/views/idea_preview.rb
@@ -1,58 +1,171 @@
 require "hive/tui/styles"
-require "hive/tui/views/format"
+require "hive/tui/views/idea_preview_layout"
+require "hive/tui/info_panel_content"
 
 module Hive
   module Tui
     module Views
-      # Bottom-strip preview for a task's source idea.md original_text.
-      # Read-only: KeyMap routes every key in :idea_preview mode back
-      # to grid; this view only renders the captured model fields.
+      # Full-screen read-only task info panel for `:idea_preview` mode.
+      # Internal module name stays IdeaPreview (KeyMap/help seam); user-
+      # facing title and footer use "info". No scrolling: overflow ends
+      # with a visible `…` and the close-key footer is always reserved.
       module IdeaPreview
-        DISMISS_HINT = "press any key to dismiss".freeze
-        MAX_VISIBLE_ROWS = 6
+        CLOSE_FOOTER = "[q] close  [Esc] close  [i] close".freeze
+        LOADING_LABEL = "Loading info…".freeze
+        UNAVAILABLE = Hive::Tui::InfoPanelContent::UNAVAILABLE
 
         module_function
 
-        def render(model, width: model.cols.to_i)
-          usable = [ width.to_i, 1 ].max
-          rows = [
-            Styles::HINT.render(truncate("Idea for #{model.idea_preview_slug}:", usable)),
-            *body_rows(model.idea_preview_text.to_s, usable),
-            Styles::HINT.render(truncate(DISMISS_HINT, usable))
-          ]
-          rows.join("\n")
-        end
+        def render(model, width: model.cols.to_i, height: model.rows.to_i)
+          cols = [ width.to_i, 1 ].max
+          rows = [ height.to_i, 3 ].max
+          state = model.idea_preview_state
 
-        def body_rows(text, width)
-          return [] if text.empty?
+          footer = Styles::HINT.render(IdeaPreviewLayout.truncate(CLOSE_FOOTER, cols))
+          header = Styles::HEADER.render(IdeaPreviewLayout.truncate(header_text(state), cols))
+          body_budget = [ rows - 2, 1 ].max
+          visible = content_lines(state, cols, budget: body_budget)
 
-          wrap_text(text, width).first(MAX_VISIBLE_ROWS).map { |line| truncate(line, width) }
+          ([ header ] + visible + [ footer ]).join("\n")
         end
 
-        # Intentional local copy of NewIdeaPrompt's simple chunking shape.
-        # NewIdeaPrompt's helper is cursor-aware and attachment-aware;
-        # extracting it would widen this read-only view change.
-        def chunk_buffer(buffer, capacity)
-          return [ "" ] if buffer.empty?
+        def header_text(state)
+          slug = state&.row&.slug || state&.content&.slug || "task"
+          "Info · #{slug}"
+        end
 
-          chunks = []
-          offset = 0
-          while offset < buffer.length
-            chunks << buffer[offset, capacity].to_s
-            offset += capacity
+        def content_lines(state, width, budget:)
+          if state.nil? || state.loading?
+            return [ IdeaPreviewLayout.truncate(LOADING_LABEL, width) ]
           end
-          chunks
-        end
+          return error_lines(state, width, budget: budget) if state.error? && state.content.nil?
 
-        def wrap_text(text, width)
-          capacity = [ width.to_i, 1 ].max
-          text.each_line(chomp: true).flat_map do |line|
-            chunk_buffer(line, capacity)
+          content = state.content
+          return error_lines(state, width, budget: budget) if content.nil?
+
+          wrap_limit = budget + 1
+          sections = []
+          sections << IdeaPreviewLayout.body_section(
+            field_lines("slug", content.slug, available: true, width: width),
+            display_priority: 1
+          )
+          sections << IdeaPreviewLayout.body_section(
+            field_lines("stage", content.stage, available: true, width: width),
+            display_priority: 1
+          )
+          sections << IdeaPreviewLayout.body_section(field_lines(
+            "created_at",
+            content.created_at,
+            available: content.created_at_available,
+            width: width
+          ), display_priority: 2)
+          idea_lines = [ label_line("idea", width) ]
+          idea_lines.concat(multiline_block(
+                              content.original_text,
+                              content.original_text_available,
+                              content.original_text_truncated,
+                              width,
+                              limit: wrap_limit
+                            ))
+          sections << IdeaPreviewLayout.body_section(idea_lines, minimum: 2, display_priority: 3)
+          sections << IdeaPreviewLayout.body_section(
+            field_lines("task folder", content.task_folder, available: true, width: width),
+            minimum: :all,
+            priority: 0,
+            display_priority: 0
+          )
+          sections << IdeaPreviewLayout.body_section(
+            field_lines(
+              "latest log",
+              content.latest_log_path,
+              available: content.latest_log_available,
+              width: width
+            ),
+            minimum: :all,
+            priority: 0,
+            display_priority: 0
+          )
+
+          if content.stage_extra_kind
+            extra_lines = [ label_line(content.stage_extra_label || "extra", width) ]
+            extra_lines.concat(multiline_block(
+                                 content.stage_extra_text,
+                                 content.stage_extra_available,
+                                 content.stage_extra_truncated,
+                                 width,
+                                 markdown: content.stage_extra_kind != :execute_log,
+                                 limit: wrap_limit
+                               ))
+            sections << IdeaPreviewLayout.body_section(
+              extra_lines,
+              minimum: 2,
+              priority: 1,
+              display_priority: 0
+            )
           end
+
+          if state.error?
+            note_lines = error_note_lines(state, width, limit: wrap_limit)
+            sections << IdeaPreviewLayout.body_section(note_lines, priority: 0)
+          end
+          IdeaPreviewLayout.fit_sections(sections, budget, width)
+        end
+
+        def error_lines(state, width, budget:)
+          msg = state&.error_message.to_s
+          msg = "could not load info" if msg.empty?
+          safe_message = IdeaPreviewLayout.safe(msg)
+          wrapped = IdeaPreviewLayout.wrap_text(
+            "Error: #{safe_message}", width, limit: budget + 1
+          )
+          return wrapped if wrapped.length <= budget
+
+          sections = [ IdeaPreviewLayout.body_section(wrapped) ]
+          IdeaPreviewLayout.fit_sections(sections, budget, width)
+        end
+
+        def error_note_lines(state, width, limit:)
+          msg = state&.error_message.to_s
+          return [] if msg.empty?
+
+          safe_message = IdeaPreviewLayout.safe(msg)
+          IdeaPreviewLayout.wrap_text("note: #{safe_message}", width, limit: limit)
+        end
+
+        def field_lines(label, value, available:, width:)
+          text = available ? value.to_s : UNAVAILABLE
+          text = UNAVAILABLE if text.empty? && !available
+          safe_text = IdeaPreviewLayout.safe(text)
+          IdeaPreviewLayout.wrap_text("#{label}: #{safe_text}", width)
+        end
+
+        def label_line(label, width)
+          Styles::HEADER.render(IdeaPreviewLayout.truncate("#{label}:", width))
         end
 
-        def truncate(line, width)
-          Views::Format.truncate(line, width.to_i)
+        def multiline_block(text, available, truncated, width, markdown: false, limit: nil)
+          unless available
+            return [ IdeaPreviewLayout.truncate("  #{UNAVAILABLE}", width) ]
+          end
+
+          body = text.to_s
+          wrapped = if markdown
+                      IdeaPreviewLayout.wrap_markdown(body, width, limit: limit)
+          else
+                      IdeaPreviewLayout.wrap_text(body, width, limit: limit)
+          end
+          if wrapped.empty?
+            wrapped = [ IdeaPreviewLayout.truncate("  (empty)", width) ]
+          end
+          if truncated
+            marker = IdeaPreviewLayout.truncate("  …", width)
+            if limit && wrapped.length >= limit
+              wrapped[-1] = marker
+            else
+              wrapped << marker
+            end
+          end
+          wrapped
         end
       end
     end
diff --git a/lib/hive/tui/views/idea_preview_layout.rb b/lib/hive/tui/views/idea_preview_layout.rb
new file mode 100644
index 00000000..adc554bf
--- /dev/null
+++ b/lib/hive/tui/views/idea_preview_layout.rb
@@ -0,0 +1,187 @@
+require "unicode/display_width"
+require "hive/tui/styles"
+require "hive/tui/text"
+
+module Hive
+  module Tui
+    module Views
+      # Cell-aware text wrapping and vertical allocation for IdeaPreview.
+      module IdeaPreviewLayout
+        module_function
+
+        def wrap_markdown(text, width, limit: nil)
+          capacity = [ width.to_i, 1 ].max
+          wrapped = []
+          text.to_s.each_line(chomp: true) do |line|
+            safe_line = safe(line)
+            if safe_line.start_with?("#")
+              heading = safe_line.sub(/\A#+\s*/, "")
+              append_chunks(wrapped, heading, capacity, limit: limit) do |chunk|
+                Styles::HEADER.render(chunk)
+              end
+            else
+              append_chunks(wrapped, safe_line, capacity, limit: limit) { |chunk| chunk }
+            end
+            return wrapped if limit && wrapped.length >= limit
+          end
+          wrapped
+        end
+
+        def wrap_text(text, width, limit: nil)
+          capacity = [ width.to_i, 1 ].max
+          wrapped = []
+          text.to_s.each_line(chomp: true) do |line|
+            append_chunks(wrapped, safe(line), capacity, limit: limit) { |chunk| chunk }
+            return wrapped if limit && wrapped.length >= limit
+          end
+          wrapped
+        end
+
+        def append_chunks(wrapped, buffer, capacity, limit:)
+          remaining = limit && limit - wrapped.length
+          return wrapped if remaining && remaining <= 0
+
+          each_chunk(buffer, capacity, limit: remaining) { |chunk| wrapped << yield(chunk) }
+          wrapped
+        end
+
+        def each_chunk(buffer, capacity, limit: nil)
+          return enum_for(__method__, buffer, capacity, limit: limit) unless block_given?
+
+          capacity = [ capacity.to_i, 1 ].max
+          if buffer.empty?
+            yield "" unless limit == 0
+            return
+          end
+
+          chunk = +""
+          chunk_width = 0
+          emitted = 0
+          buffer.to_s.each_grapheme_cluster do |grapheme|
+            width = display_width(grapheme)
+            if !chunk.empty? && chunk_width + width > capacity
+              yield chunk
+              emitted += 1
+              return if limit && emitted >= limit
+              chunk = +""
+              chunk_width = 0
+            end
+
+            if width > capacity
+              yield "…"
+              emitted += 1
+              return if limit && emitted >= limit
+              next
+            end
+
+            chunk << grapheme
+            chunk_width += width
+          end
+          yield chunk unless chunk.empty? || (limit && emitted >= limit)
+        end
+
+        def body_section(lines, minimum: :all, priority: 2, display_priority: 2)
+          cleaned = Array(lines).compact
+          required = minimum == :all ? cleaned.length : [ minimum.to_i, cleaned.length ].min
+          {
+            lines: cleaned,
+            minimum: required,
+            priority: priority,
+            display_priority: display_priority
+          }
+        end
+
+        # Fit required fields before giving either long artifact more rows.
+        def fit_sections(sections, budget, width)
+          sections = sections.reject { |section| section[:lines].empty? }
+          flattened = sections.flat_map { |section| section[:lines] }
+          return flattened if flattened.length <= budget
+          return [ truncate("…", width) ] if budget <= 1
+
+          inline_marker = budget <= sections.length
+          available = inline_marker ? budget : budget - 1
+          allocated = initial_allocation(sections, available)
+          available -= allocated.sum
+          available = allocate_minimums(sections, allocated, available)
+          grow_allocations(sections, allocated, available)
+
+          kept = sections.each_with_index.flat_map do |section, index|
+            section[:lines].first(allocated[index])
+          end
+          if inline_marker
+            kept[-1] = truncate("#{kept[-1]} …", width)
+          else
+            kept << truncate("…", width)
+          end
+          kept
+        end
+
+        def truncate(line, width)
+          capacity = width.to_i
+          return "" if capacity <= 0
+
+          text = safe(line.to_s)
+          return text if display_width(text) <= capacity
+
+          "#{slice_cells(text, capacity - 1)}…"
+        end
+
+        def safe(text)
+          Hive::Tui::Text.sanitize(text)
+        end
+
+        def display_width(text)
+          Unicode::DisplayWidth.of(text.to_s)
+        end
+
+        def slice_cells(text, capacity)
+          return "" if capacity <= 0
+
+          width = 0
+          result = +""
+          text.each_grapheme_cluster do |grapheme|
+            grapheme_width = display_width(grapheme)
+            break if width + grapheme_width > capacity
+
+            result << grapheme
+            width += grapheme_width
+          end
+          result
+        end
+
+        def initial_allocation(sections, available)
+          allocated = Array.new(sections.length, 0)
+          sections.each_index.sort_by do |index|
+            [ sections[index][:display_priority], index ]
+          end.first(available).each { |index| allocated[index] = 1 }
+          allocated
+        end
+
+        def allocate_minimums(sections, allocated, available)
+          sections.each_index.sort_by { |index| [ sections[index][:priority], index ] }.each do |index|
+            while available.positive? && allocated[index] < sections[index][:minimum]
+              allocated[index] += 1
+              available -= 1
+            end
+          end
+          available
+        end
+
+        def grow_allocations(sections, allocated, available)
+          while available.positive?
+            index = sections.each_index.find do |candidate|
+              allocated[candidate] < sections[candidate][:lines].length
+            end
+            break if index.nil?
+
+            allocated[index] += 1
+            available -= 1
+          end
+        end
+
+        private_class_method :append_chunks, :slice_cells,
+                             :initial_allocation, :allocate_minimums, :grow_allocations
+      end
+    end
+  end
+end
